option explicit
dim FSO 'objects

class Access
	public Level: public Name: public InFile	
end class

class Command
	public Name: public FunctionName: public Level: public Description: public InFile
end class

dim Script_Path,Include_Path ' variants to hold arrays
dim levels(): redim levels(0) 'dim then redim to init
dim Commands(): redim Commands(0) ' dim then redim to init

Script_Path=array("..\sma_storage") ' create scritps entries
Include_Path=array("include") 'create includes entries

set FSO=createobject("scripting.filesystemobject") 'create filesystem access object

'------------------------------------------------------------------------------------------------------------------------
' start here

	LoadAccessFromIncludes
	LoadScripts

	dim TSO
	set TSO=fso.opentextfile("..\AdminMod_Commands.html",2,true)
	WriteHTMLHeader(TSO)
	tso.write(CreateCommandsTable)
	tso.write("<p>&nbsp;</p>")
	tso.write(CreateAccessTable)
	WriteHTMLFooter(TSO)
	tso.close
	set tso=nothing

'	msgbox "Done",vbokonly,"Done"

' end
	
'------------------------------------------------------------------------------------------------------------------------
public sub LoadScripts
	dim x,folder,file
	for x=0 to ubound(Script_Path)
		if fso.folderexists(Script_Path(x)) then
			set folder =fso.getfolder(Script_Path(x))
			for each file in folder.files
				if len(file.name) >4 then
					if lcase(right(file.name,4))=".sma" then
						LoadAccessFromScript Script_Path(x)&"\"&File.name
						LoadCommandsFromScript Script_Path(x)&"\"&File.name
					end if
				end if
			next
		end if
	next
end sub
'------------------------------------------------------------------------------------------------------------------------
public function LoadAccessFromIncludes()
	dim x,InVar,regex,folder,file,tso
	set regex= new regexp
	for x =0 to ubound(Include_Path)
		regex.pattern = "#define (ACCESS_.*?[A-Za-z_-]) (1<<(?:3[0-1]|[1-2][0-9]|[0-9])|[0-9]{0,10})"
		'regex.pattern ="#define (ACCESS_.*?[A-Za-z_-]) (1<<(?:3[0-1]|[1-2][0-9]|[0-9])|[0-9]{0,10}(?=[^<]))"
			
		if fso.folderexists(Include_path(x)) then
			set folder=fso.getfolder(Include_path(x))
			for each file in folder.files
				if len(file.name)> 4 then
					if lcase(right(file.name,4))=".inc" then
						set	tso=fso.opentextfile(Include_Path(x)&"\"&file.name,1,false)
						do while tso.atendofstream=false
							invar=tso.readline
							if regex.test(invar) =true then
								AddLevel Invar,regex.pattern,file.name
							end if	
						loop
						tso.close
						set tso=nothing						
					end if
				end if
			next
			set folder=nothing
		end if
	next
end function
'------------------------------------------------------------------------------------------------------------------------
public sub Addlevel(Line,Pattern,FileName)
	dim regex,matches,match,rightstr,leftstr,number
	set regex= new regexp
	regex.pattern=pattern
	set matches=regex.execute(line)
	set match=matches(0)
	if typename(levels(ubound(levels)))<> "Empty" then redim preserve levels(ubound(levels)+1) 'else msgbox "found emtpy"
	if instr(1,match.submatches(1),"<<")>0 then
		rightstr=right(match.submatches(1),(len(match.submatches(1))-instrrev(match.submatches(1),"<<"))-1)
		if not isnumeric(rightstr) then exit sub
		leftstr=left(match.submatches(1),instr(1,match.submatches(1),"<<")-1)
		if not isnumeric(leftstr) then exit sub
		if cint(rightstr)>31 then exit sub
		number= 2 ^ cint(rightstr)		
	else
		number=match.submatches(1)
	end if
	
	set levels(ubound(levels))=new Access
	levels(ubound(Levels)).level=number
	levels(ubound(Levels)).name=match.submatches(0)
	
	if instr(1,FileName,"\")> 0 then
		levels(ubound(levels)).InFile = right(FileName,len(FileName)-(instrrev(FileName,"\")))
	else
		levels(ubound(levels)).InFile=FileName
	end if
	
	set match=nothing
	set matches=nothing
	set regex=nothing
end sub
'------------------------------------------------------------------------------------------------------------------------
private sub AddCommand(Line,Pattern,FileName)
	dim regex,matches,match,bound
	set regex= new regexp
	regex.pattern=pattern
	set matches=regex.execute(line)
	set match=matches(0)
	if typename(Commands(ubound(Commands)))<> "Empty" then redim preserve Commands(ubound(Commands)+1) 'else msgbox "found emtpy"
	bound=ubound(commands)
	set Commands(bound)=new Command
	Commands(bound).name=match.submatches(0)
	Commands(bound).functionname=match.submatches(1)
	Commands(bound).level=match.submatches(2)
	Commands(bound).description =replace(replace(match.submatches(3),">","&gt;"),"<","&lt;")
	if instr(1,FileName,"\")>0 then
		Commands(bound).InFile	=right(filename,len(FileName)-instrrev(FileName,"\"))
	else
		Commands(bound).InFile =FileName
	end if
	if len(Commands(bound).InFile)>4 then
		if lcase(right(Commands(bound).InFile,4))=".sma" then
			Commands(bound).InFile=left(Commands(bound).InFile,len(Commands(bound).InFile)-4)
		end if
	end if
	set regex=nothing
	set matches=nothing
	

end sub
'------------------------------------------------------------------------------------------------------------------------
public sub LoadAccessFromScript(ScriptPath)
	dim lTSO,InVar,regex
	set regex= new regexp
	if fso.fileexists(Scriptpath) then
		regex.pattern="#define (ACCESS_.*?[A-Za-z_-]) (1<<(?:3[0-1]|[1-2][0-9]|[0-9])|[0-9]{0,10})"
		set lTSo=fso.opentextfile(ScriptPath,1,false)
		do while lTSO.atendofstream<>true
			invar=lTSO.readline
			if regex.test(InVar) then AddLevel inVar,regex.pattern,scriptpath
		loop
		lTSO.close
		set lTSO=nothing		
	end if
end sub
'------------------------------------------------------------------------------------------------------------------------
public sub LoadCommandsFromScript(ScriptPath)
' plugin_registercmd\(\"(.*?)\",\"(.*?)\",(.*?)(?:\)|,\"(.*?)\"\))
' plugin_registercmd\([ \t]*\"(.*?)\"[ \t]*,[ \t]*\"(.*?)\"[ \t]*,[ \t]*(.*?)[ \t]*(?:\)|,[ \t]*\"(.*?)\"[ \t]*\));
	dim lTSO,InVar,regex
	set regex= new regexp
	if fso.fileexists(Scriptpath) then
		regex.pattern="plugin_registercmd\([ \t]*\""(.*?)\""[ \t]*,[ \t]*\""(.*?)\""[ \t]*,[ \t]*(.*?)[ \t]*(?:\)|,[ \t]*\""(.*?)\""[ \t]*\));"
		set lTSo=fso.opentextfile(ScriptPath,1,false)
		do while lTSO.atendofstream<>true
			invar=lTSO.readline
			if regex.test(InVar) then AddCommand inVar,regex.pattern,scriptpath
		loop
		lTSO.close
		set lTSO=nothing		
	end if
end sub
'------------------------------------------------------------------------------------------------------------------------
public sub WriteHTMLHeader(Stream)
	stream.write("<html>"&vbcrlf&"<head>"&vbcrlf&"<title>Admin Mod Commands</title>"&vbcrlf&vbcrlf)
	stream.write("<style ""text/css"">"&vbcrlf&"A { text-decoration: none; border-bottom: none; }"&vbcrlf&".name { display:inline; }"&vbcrlf&".access { font-size:80%; display:inline; }"&vbcrlf&".description { display:inline; }"&vbcrlf&".function { display:inline; }"&vbcrlf&".plugin { display:inline; }"&vbcrlf&"</style>"&vbcrlf&vbcrlf&"<body>"&vbcrlf)
	stream.write(GetJavaScript)
	stream.write(vbcrlf&vbcrlf&"</head>"&vbcrlf&vbcrlf)
end sub
'------------------------------------------------------------------------------------------------------------------------
private sub WriteHTMLFooter(Stream)
	stream.write("</html></body>")
end sub
'------------------------------------------------------------------------------------------------------------------------
private function GetJavaScript()
	dim lTSO,InVar,RetVar,readme
	set lTSO=fso.opentextfile(wscript.scriptfullname,1,false)
	do while lTSO.atendofstream<>true
		invar=ltso.readline
		if readme=false then
			if instr(1,invar,chr(60)&"SCRIPT MARKER"&chr(62)) >0 then readme=true
		else
			if instr(1,invar,chr(60)&"SCRIPT MARKER"&chr(62)) >0 then
				readme=false
				exit do
			else
				if len(Invar)>0 then Retvar=RetVar&vbcrlf&right(Invar,len(Invar)-1)
			end if
		end if
	loop
	lTSO.close
	set lTSO=nothing
	GetJavaScript = RetVar
end function
'------------------------------------------------------------------------------------------------------------------------
public function CreateCommandsTable
dim OutVar,LineVar,x
Outvar="<table border=1 cellspacing=0 frame=box rules=all align=right><tr><td>"&vbcrlf&"<input type=""checkbox"" name=""showaccess"" value=""0"" onclick=""toggle(this,'name');"" CHECKED DISABLED>Show Names"&vbcrlf&"</td><td>"&vbcrlf&"<input type=""checkbox"" name=""showaccess"" value=""0"" onclick=""toggle(this,'access');"" CHECKED>Show access levels"&vbcrlf&"</td><td>"&vbcrlf&"<input type=""checkbox"" name=""showaccess"" value=""0"" onclick=""toggle(this,'description');"" CHECKED DISABLED>Show descriptions"&vbcrlf&"</td><td>"&vbcrlf&"<input type=""checkbox"" name=""showaccess"" value=""0"" onclick=""toggle(this,'function');"" CHECKED>Show functions"&vbcrlf&"</td><td>"&vbcrlf&"<input type=""checkbox"" name=""showaccess"" value=""0"" onclick=""toggle(this,'plugin');"" CHECKED>Show plugins"&vbcrlf&"</td></tr></table><p>&nbsp;</p>"&vbcrlf
OutVar=outvar&"<table ID=commands border=1 cellspacing=0 frame=box rules=all>"&vbcrlf
OutVar=OutVar&"<tr><td ID=CommandNameLabel>Command</td><td ID=CommandAccessLabel>Access Level</td><td ID=CommandDescriptionLabel>Description</td><td ID=CommandFunctionLabel>Function</td><td ID=CommandPluginLabel>Plugin</td></tr>"&vbcrlf
OutVar=OutVar&"<tr></tr>"
for x=0 to ubound(Commands)
	LineVar="<tr><td class=name>"&Commands(x).name
	LineVar=LineVar&"</td><td class=access><a href=""#"&Commands(x).level&""">"&Commands(x).level&"</a>"
	if Commands(x).description="" then LineVar=LineVar&"<td class=description></td>" else	LineVar=LineVar&"</td class=description><td>"&Commands(x).description
	LineVar=LineVar&"</td><td class=function>"&Commands(x).functionname
	LineVar=LineVar&"</td><td class=plugin>"&Commands(x).InFile
	LineVar=LineVar&"</td></tr>"&vbcrlf
	OutVar=OutVar&LineVar
next
OutVar=OutVar&"</table>"&vbcrlf&vbcrlf
CreateCommandsTable=Outvar
end function
'------------------------------------------------------------------------------------------------------------------------
public function CreateAccessTable
dim x,y,z,LineVar,OutVar
outvar="<table border=1 cellspacing=0 frame=box rules=all align=center>"&vbcrlf
outvar=outvar&"<tr><td>Name</td><td>Level</td><td>Declared In</td><td>Instances</td></tr>"&vbcrlf
OutVar=OutVar&"<tr><td colspan=4 height=10></td></tr>"&vbcrlf

for x=0 to ubound(Levels)
	LineVar="<tr><td class=access><a name=""#"&Levels(x).name&""">"&Levels(x).name&"</td>"
	LineVar=LineVar&"<td>"&levels(x).level&"</td>"
	LineVar=LineVar&"<td>"&Levels(x).InFile&"</td>"
	LineVar=LineVar&"<td>"
	if x<>0 and x <>ubound(levels) then
		for y = 0 to x-1 'previously decalred
			if levels(x).name=levels(y).name then
				if lcase(right(levels(y).InFile,4))=".sma" then
					LineVar=LineVar&"<b>(also:</b>"&levels(y).Infile&"<b>,</b>"&levels(y).level&"<b>)</b><br>"
				else
					LineVar=LineVar&"<b>(previously:</b>"&levels(y).Infile&"<b>,</b>"&levels(y).level&"<b>)</b><br>"
				end if
			end if
		next
		for z =x+1 to ubound(levels) 'redeclared
			if levels(x).name=levels(z).name then
				if lcase(right(levels(y).InFile,4))=".sma" then
					LineVar=LineVar&"<b>(also:</b>"&levels(z).Infile&"<b>,</b>"&levels(z).level&"<b>)</b><br>"
				else
					LineVar=LineVar&"<b>(later:</b>"&levels(z).Infile&"<b>,</b>"&levels(z).level&"<b>)</b><br>"
				end if
			end if
		next
	end if
	LineVar=LineVar&"</td></tr>"
	outvar=outvar&LineVar&vbcrlf
next
Outvar=outvar&"</table>"&vbcrlf
CreateAccessTable=outvar
end function

' the following text is the quoted javascript for the html file, it will be read out and pasted into the script header, any changes here will have the required effects
'<SCRIPT MARKER>
'<SCRIPT LANGUAGE="JScript">
'function toggle (Check,Type) {
'	var coll = commands.all.tags("TD");
'	if (coll!=null)
'	{
'	//alert(Type);
'		for (i=0; i<coll.length; i++)
'		if (coll[i].className == Type)
' 		{
'			if (Check.checked==false) { coll[i].style.display='none'; } else { coll[i].style.display='inline'; }
'		}
'	}
'	if (Type =='name') {
'		if (Check.checked==false) {CommandNameLabel.style.display='none'; } else { CommandNameLabel.style.display='inline';}
'	} else if (Type == 'access') {
'		if (Check.checked==false) { CommandAccessLabel.style.display='none'; } else { CommandAccessLabel.style.display='inline'; }
'	} else if ( Type == 'description' ) {
'		if (Check.checked==false) { ComandDescriptionLabel.style.display='none'; } else { CommandDescriptionLabel.style.display='inline';}
'	} else if ( Type == 'function' ) {
'		if (Check.checked==false) { CommandFunctionLabel.style.display='none'; } else { CommandFunctionLabel.style.display='inline';}
'	} else if ( Type == 'plugin' ) {
'		if (Check.checked==false) { CommandPluginLabel.style.display='none'; } else { CommandPluginLabel.style.display='inline';}
'	}
'}
'</SCRIPT>
'<SCRIPT MARKER>
