/*
 * ===========================================================================
 *
 * $Id: plugin_log.sma,v 1.0 2005/15/08 13:12:07 sdal Exp $
 *
 *
 * Copyright (c) 1999-2003 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ===========================================================================
 */

#include <plugin>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[10]="2.50.60";

new g_plugin;

new g_MainDir[MAX_TEXT_LENGTH]="addons/adminmod/config/";

#define MAX_LOGFILES	5
//define LOG Files
#define LOG_SAY	0
#define LOG_RETRIBUTION 1
#define LOG_ADMIN 2
#define LOG_BAN 3
#define LOG_ANTIFLOOD 4


new g_LogFiles[MAX_LOGFILES][]={
	"log_say.txt",
	"log_retribution.txt",
	"log_admin.txt",
	"log_banned.txt",
	"log_antiflood.txt"
};

#define MAX_RETR_CMDS	18
new g_Retribution_Cmds[MAX_RETR_CMDS][]={
	"slap",
	"slay",
	"kick",
	"bury",
	"unbury",
	"gag",
	"ungag",
	"llama",
	"unllama",
	"slayteam",
	"ct",
	"t",
	"vote_kick",
	"execclient",
	"execall",
	"execteam",
	"restrict",
	"unrestrict"
};

public plugin_init() {
	new iwrite;
	iwrite = getvar("file_access_write");
	if(iwrite){
		plugin_registerinfo("AdminMod Log Plugin","Logs all STEAM_IDs, say/say_team and admin_ commands in special logfiles",STRING_VERSION);
		plugin_registercmd("admin_log","admin_log",ACCESS_CONFIG,"admin_log <on/off>: turns plugin on/off");
		if(!get_vaultnumdata("log_plugin",g_plugin)){
			set_vaultnumdata("log_plugin",1);
			g_plugin=1;
		}
	}else{
		plugin_registerinfo("Admin Log Plugin","PLUGIN DISABLED, because file_access_write is not set to 1 in adminmod.cfg",STRING_VERSION);
		selfmessage("[LOG_PLUGIN] Plugin is disabled, because file_access_write is not set to 1 in adminmod.cfg");
	}		
	return PLUGIN_CONTINUE;
}

//////////////////////
//	ADMIN COMMANDS	//
//////////////////////
//turn plugin on/off
public admin_log(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)){
		g_plugin=check_param(Data);
		set_vaultnumdata("log_plugin",g_plugin);
	}	
	snprintf(Data,MAX_DATA_LENGTH,"[LOG_PLUGIN] Plugin is set to %i",g_plugin);
	selfmessage(Data);
	return PLUGIN_HANDLED;
}

public plugin_command(HLCommand,HLData,HLUserName,UserIndex){
	if(g_plugin){
		new Data[MAX_DATA_LENGTH];
		new File[MAX_TEXT_LENGTH];
		new Command[MAX_COMMAND_LENGTH];
		new i;
		new iAccess;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		if(strcmp(Command,"cmd_success")!=0){
			if(strcmp(Command,"say")==0 || strcmp(Command,"say_team")==0){
				strstripquotes(Data);
				snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_MainDir,g_LogFiles[LOG_SAY]);
				log_to_file(UserIndex,Command,Data,File);
				return PLUGIN_CONTINUE;
			}else if(strncmp(Command,"admin_",6)==0){
				if(strcmp(Command,"admin_ban")==0 || strcmp(Command,"admin_unban")==0 || strcmp(Command,"admin_timeban")==0){
					snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_MainDir,g_LogFiles[LOG_BAN]);
					log_to_file(UserIndex,Command,Data,File);
					return PLUGIN_CONTINUE;
				}else{
					for(i=0;i<=MAX_RETR_CMDS;i++){
						if(strcmp(Command[6],g_Retribution_Cmds[i])==0){
							snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_MainDir,g_LogFiles[LOG_RETRIBUTION]);
							log_to_file(UserIndex,Command,Data,File);
							return PLUGIN_CONTINUE;
							break;
						}
					}
				}
			}
			//rcon command from server console
			if(!UserIndex){
				snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_MainDir,g_LogFiles[LOG_ADMIN]);
				log_to_file(UserIndex,Command,Data,File);
			}else if(get_access(UserIndex)>=1){
				plugin_checkcommand(Command,iAccess);
				//log only commands, which have accesslevel > 0
				if(iAccess>0){
					snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_MainDir,g_LogFiles[LOG_ADMIN]);
					log_to_file(UserIndex,Command,Data,File);
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}
