/*
 * ===========================================================================
 *
 * $Id: plugin_antiflood.sma,v 1.5 2003/09/11 19:41:07 darope Exp $
 *
 *
 * Copyright (c) 1999-2003 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ===========================================================================
 * - added helper function convert_string_all
 * - added helper function execute_cmd
 * - added reason to admin_ban
 * - moved exec commands from plugin_retribution to plugin_base
 * - moved all say commands to plugin_message
 * - changed accesslevel of admin_userlist
 * - added default_map.cfg which is loaded in plugin_init
 * - changed admin_map to check map with valid_mapex
 * - added new function admin_timeban
 * - added new function admin_map_exec to change methode of changing map
 */

#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "2.50.60.rc1";

#define ACCESS_EXECCLIENT 65536

new g_map_exec;

public plugin_init() {
	plugin_registerinfo("AdminMod Base Plugin","Basic Admin Mod commands.",AM_VERSION_STRING);
	plugin_registercmd("admin_ban","admin_ban",ACCESS_BAN,"admin_ban <target or STEAM_ID or IP> [<minutes>] [<reason>]: Bans target. 0 is permanent.");
	plugin_registercmd("admin_banip","admin_ban",ACCESS_BAN,"admin_banip <target or STEAM_ID or IP> [<minutes>] [<reason>]: Bans targets ip address. 0 is permanent.");
	plugin_registercmd("admin_cfg","admin_cfg",ACCESS_CONFIG,"admin_cfg <config file>: Executes config file on server.");
	plugin_registercmd("admin_execall","admin_execall",ACCESS_EXECCLIENT,"admin_execall <command>: Force everyone to execute command.");
	plugin_registercmd("admin_execclient","admin_execclient",ACCESS_EXECCLIENT,"admin_execclient <target> <command>: Force target to execute command.");
	plugin_registercmd("admin_execteam","admin_execteam",ACCESS_EXECCLIENT,"admin_execteam <team> <command>: Force everyone on team to execute command.");
	plugin_registercmd("admin_fraglimit","admin_fraglimit",ACCESS_FRAGLIMIT,"admin_fraglimit <fraglimit>: Sets the mp_fraglimit cvar.");
	plugin_registercmd("admin_friendlyfire","admin_friendlyfire",ACCESS_FRIENDLY_FIRE,"admin_friendlyfire <friendlyfire>: Sets the mp_friendlyfire cvar.");
	plugin_registercmd("admin_gravity","admin_gravity",ACCESS_GRAVITY,"admin_gravity <gravity>: Sets the sv_gravity cvar.");
	plugin_registercmd("admin_hostname","admin_hostname",ACCESS_CONFIG,"admin_hostname <name>: Sets the hostname cvar.");
	plugin_registercmd("admin_kick","admin_kick",ACCESS_KICK,"admin_kick <target> [<reason>]: Kicks target.");
	plugin_registercmd("admin_listmaps","admin_listmaps",ACCESS_ALL,"admin_listmaps: Shows maps in mapcycle.");
	plugin_registercmd("admin_map","admin_map",ACCESS_MAP,"admin_map <map>: Changes map.");
	plugin_registercmd("admin_map_exec","admin_map_exec",ACCESS_CONFIG,"admin_map_exec <0/1>: Sets methode for changing map.");	
	plugin_registercmd("admin_nextmap","admin_nextmap",ACCESS_ALL,"admin_nextmap: Shows next map in cycle.");
	plugin_registercmd("admin_nopass","admin_pass",ACCESS_PASS,"admin_nopass: Clears the server's password.");
	plugin_registercmd("admin_pass","admin_pass",ACCESS_PASS,"admin_pass <password>: Sets the server's password.");
	plugin_registercmd("admin_pause","admin_pause",ACCESS_PAUSE,"admin_pause: Sets the pausable cvar to 1.");
	plugin_registercmd("admin_rcon","admin_rcon",ACCESS_RCON,"admin_rcon <cmd>: Executes rcon command.");
	plugin_registercmd("admin_reload","admin_reload",ACCESS_RELOAD,"admin_reload: Reloads Admin Mod files.");
	plugin_registercmd("admin_servercfg","admin_servercfg",ACCESS_CONFIG,"admin_servercfg <config file>: Sets the config file as the server's default.");
	plugin_registercmd("admin_teamplay","admin_teamplay",ACCESS_TEAMPLAY,"admin_teamplay <teamplay>: Sets the mp_teamplay cvar.");
	plugin_registercmd("admin_timeban","admin_ban",ACCESS_KICK,"admin_timeban <player>: Bans player for 30 minutes.");
	plugin_registercmd("admin_timeleft","admin_timeleft",ACCESS_TIMELEFT,"admin_timeleft: Shows the time left.");
	plugin_registercmd("admin_timelimit","admin_timelimit",ACCESS_TIMELIMIT,"admin_timelimit <timelimit>: Sets the mp_timelimit cvar.");
	plugin_registercmd("admin_unpause","admin_pause",ACCESS_PAUSE,"admin_unpause: Sets the pausable cvar to 0.");
	plugin_registercmd("admin_unban","admin_unban",ACCESS_BAN,"admin_unban <STEAM_ID or IP>: Unbans target.");
	plugin_registercmd("admin_userlist","admin_userlist",ACCESS_TIMELIMIT,"admin_userlist [<name>]: Shows a list of users.");
	
	new strMap[MAX_DATA_LENGTH];
	new ExecCommand[MAX_DATA_LENGTH];
	
	snprintf(ExecCommand, MAX_DATA_LENGTH, "default_map.cfg", strMap);
	if ( fileexists(ExecCommand) ) {
			snprintf(ExecCommand, MAX_DATA_LENGTH, "exec %s.cfg", strMap);
			log(ExecCommand);
			exec(ExecCommand);
	}
	
	currentmap(strMap, MAX_DATA_LENGTH);
	snprintf(ExecCommand, MAX_DATA_LENGTH, "%s.cfg", strMap);
	if ( fileexists(ExecCommand) ) {
		snprintf(ExecCommand, MAX_DATA_LENGTH, "exec %s.cfg", strMap);
		log(ExecCommand);
		exec(ExecCommand);
	}
	
	if(!get_vaultnumdata("map_exec",g_map_exec)){
		set_vaultnumdata("map_exec",0);
		g_map_exec=0;
	}

	return PLUGIN_CONTINUE;
}

execute_cmd(HLCommand,HLData,HLUserName,sCommand[]){
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	execute_command(User,Command,sCommand,Data);
}

/* admin_ban <target or STEAM_ID> [<minutes>] [<reason>]
	 admin_banip <target or STEAM_ID> [<minutes>] [<reason>]*/
public admin_ban(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new ban_user[MAX_DATA_LENGTH];
	new strReason[MAX_TEXT_LENGTH];
	new strTime[MAX_TEXT_LENGTH];
	new BanTime = 0;
	new iBanType = bBanByID;
	new TargetName[MAX_NAME_LENGTH];
	new TargetAuthID[MAX_AUTHID_LENGTH];
	new TargetIP[MAX_NAME_LENGTH];
	new iTargetUserIndex;
	new iTargetTeam;
	new iTargetSessionID;
		
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	strstripquotes(Data);

	strsep(Data," ",ban_user,MAX_DATA_LENGTH,strTime,MAX_TEXT_LENGTH,strReason,MAX_TEXT_LENGTH);
	
	if(strcmp(Command,"admin_timeban")==0){
		BanTime=30;
		strcat(strTime,strReason,MAX_TEXT_LENGTH);
		strcpy(strReason,strTime,MAX_TEXT_LENGTH);
	}else{
		BanTime = strtonum(strTime);
	}
	
	if(BanTime==0){
		strcat(strTime,strReason,MAX_TEXT_LENGTH);
		strcpy(strReason,strTime,MAX_TEXT_LENGTH);
	}
	
	if(strcmp(Command,"admin_banip")==0 || getvar("sv_lan") != 0){
		iBanType = bBanByIP;
	}
	
	if(check_user(ban_user)) {
		get_username(ban_user,TargetName,MAX_NAME_LENGTH);
		if(check_immunity(TargetName)==1) {
			snprintf(Data, MAX_TEXT_LENGTH, "Laf. You can't ban '%s', you silly bear.", TargetName);
			messageex(User,Data,print_console);
			return PLUGIN_HANDLED;
		}
		if(BanTime==0){
			snprintf(Data,MAX_TEXT_LENGTH,"You are banned permanent. Reason: %s",strReason);
		}else{
			snprintf(Data,MAX_TEXT_LENGTH,"You are banned for %i minutes. Reason: %s",BanTime,strReason);
		}
		messageex(TargetName,Data,print_console);
		//prepare log entry
		get_userindex(TargetName,iTargetUserIndex);
		if(playerinfo(iTargetUserIndex,TargetName,MAX_NAME_LENGTH,iTargetSessionID,_,iTargetTeam,_,TargetAuthID)){
			get_userIP(TargetName,TargetIP,MAX_NAME_LENGTH);
			snprintf(Data,MAX_DATA_LENGTH,"%s<%i><%s><%i><%s> - Bantime: %i - Reason: %s",TargetName,iTargetSessionID,TargetAuthID,iTargetTeam,TargetIP,BanTime,strReason);
			log_to_file(UserIndex,Command,Data,"addons/adminmod/config/log_banned.txt");
		}		
		ban(TargetName,BanTime,iBanType);
		say_command(User,Command,TargetName);
		return PLUGIN_HANDLED;
	}
	//using steam_id or IP
	say_command(User,Command,Data);
	//prepare log entry
	snprintf(Data,MAX_DATA_LENGTH,"%s - Bantime: %i - Reason: %s",TargetName,BanTime,strReason);
	log_to_file(UserIndex,Command,Data,"addons/adminmod/config/log_banned.txt");
	ban(ban_user,BanTime,iBanType);
	
	return PLUGIN_HANDLED;
}

/* admin_cfg <config file> */
public admin_cfg(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"exec");
	return PLUGIN_HANDLED;
}

/* admin_execall <command> */
public admin_execall(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new Target[MAX_NAME_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	for(i=1; i<=maxplayers; i++) {
		strinit(Target);
		if(playerinfo(i,Target,MAX_NAME_LENGTH)==1) {
			if(check_immunity(Target)==0 && i != UserIndex) {
				execclient(Target,Data);
			}
		}
	}
	say_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

/* admin_execclient <target> <command> */
public admin_execclient(HLCommand,HLData,HLUserName,UserIndex) {
	new Cmd[MAX_DATA_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	strbreak(Data, Target, Cmd, MAX_TEXT_LENGTH);
	if (strlen(Cmd) == 0) {
		selfmessage( "Unparsable format: no command found.");
		return PLUGIN_HANDLED;
	} else if(check_user(Target)==0) {
		selfmessage("Unrecognized player: ");
		selfmessage(Target);
		return PLUGIN_HANDLED;
	}
	get_username(Target,TargetName,MAX_NAME_LENGTH);
	say_command(User,Command,TargetName);
	if(check_immunity(TargetName)!=0) {
		snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't control %s, you silly bear.", TargetName);
		messageex(User, Text, print_chat);
	} else {
		if (execclient(TargetName,Cmd)==0) {
			selfmessage("Failed.");
		} else {
			selfmessage("Succeeded.");
			snprintf(Cmd,MAX_DATA_LENGTH,"executes %s at",Cmd);
		}
	}
	return PLUGIN_HANDLED;
}

/* admin_execteam <team> <command> */
public admin_execteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Cmd[MAX_TEXT_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new maxplayers = maxplayercount();
	new ExecTeam = 0;
	new strTeam[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new Team;
	new User[MAX_NAME_LENGTH];
		
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	strbreak(Data, strTeam, Cmd, MAX_TEXT_LENGTH);
	if (strlen(Cmd) == 0) {
		selfmessage( "Unparsable format: no command found.");
		return PLUGIN_HANDLED;
	}
	ExecTeam = strtonum(strTeam);

	if(ExecTeam > 0) {
		snprintf(Data,MAX_DATA_LENGTH,"executes %s at",Cmd);
		for(i=1; i<=maxplayers; i++) {
			strinit(Target);
			if(playerinfo(i,Target,MAX_NAME_LENGTH,_,_,Team)==1) {
				if(Team==ExecTeam && i != UserIndex) {
					if(check_immunity(Target)==0) {
						execclient(Target,Cmd);
					}
				}
			}
		}
		say_command(User,Command,Data);
	} else {
		selfmessage("The team to exec must be a number.");
	}
	return PLUGIN_HANDLED;
}

/* admin_fraglimit <fraglimit> */
public admin_fraglimit(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"mp_fraglimit");
	return PLUGIN_HANDLED;
}

/* admin_friendlyfire <friendlyfire> */
public admin_friendlyfire(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"mp_friendlyfire");
	return PLUGIN_HANDLED;
}

/* admin_gravity <gravity> */
public admin_gravity(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"sv_gravity");
	return PLUGIN_HANDLED;
}

/* admin_hostname <name> */
public admin_hostname(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new sHostName[MAX_DATA_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	snprintf(sHostName, MAX_DATA_LENGTH, "^"%s^"", Data);
	execute_command(User,Command,"hostname",sHostName);
	return PLUGIN_HANDLED;
}


/* admin_kick <target> [<reason>] */
public admin_kick(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new kick_user[MAX_DATA_LENGTH];
	new Reason[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	strbreak(Data,kick_user,Reason,MAX_DATA_LENGTH);
	if ( check_user(kick_user) == 1) {
		new real_user[MAX_NAME_LENGTH];
		get_username(kick_user,real_user,MAX_NAME_LENGTH);
		say_command(User,Command,real_user);
		if(check_immunity(kick_user)!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't kick '%s', you silly bear.", real_user);
			messageex(User, Text, print_chat);
		} else {
			if (strlen(Reason) != 0) {
				snprintf(Text, MAX_TEXT_LENGTH, "You have been kicked because %s", Reason);
				messageex(real_user, Text,print_console);
			}
			kick(real_user);
		}
	} else {
		selfmessage("Unrecognized player: ");
		selfmessage(kick_user);
	}
	return PLUGIN_HANDLED;
}

/* admin_listmaps */
public admin_listmaps(HLCommand,HLData,HLUserName,UserIndex) {
	new curmap[100];
	selfmessage("The maps on the mapcycle are:");
	list_maps();
	selfmessage("and the current map is:");
	currentmap(curmap,100);
	selfmessage(curmap);
	return PLUGIN_HANDLED;
}

/* admin_map <map> */
public admin_map(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	if (valid_mapex(Data,1)==1) {
		say_command(User,Command,Data);
		if(g_map_exec){
			snprintf(Data,MAX_DATA_LENGTH,"changelevel %s",Data);
			exec(Data);
		}else{
			changelevel(Data, 4);
			//set_timer("ChangeMap",4,0,Data);
		}
	} else {
		selfmessage("Map does not exist or map is not allowed");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

public admin_map_exec(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iSet;
	
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	iSet=check_param(Data);
	
	if(iSet){
		set_vaultnumdata("map_exec",iSet);
		g_map_exec=iSet;
	}else{
		set_vaultnumdata("map_exec",0);
		g_map_exec=0;
	}
	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN] map_exec is set to %i (0=normal/1=exec)",iSet);
	log_command(User,Command,Data);
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

/* admin_nextmap */
public admin_nextmap(HLCommand,HLData,HLUserName,UserIndex) {
	new strDummy[1];
	nextmap(strDummy,0);
	return PLUGIN_HANDLED;
}

/* admin_pass <password>
	 admin_nopass */
public admin_pass(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Msg[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	/* Don't use execute_command here, unless you want your password to
	be publicly broadcast... instead we use our own message */
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	if (streq(Command, "admin_nopass")==1) {
		strcpy(Data,"^"^"",MAX_DATA_LENGTH);
	} else {
		/* If they didn't supply a password, show them the current one. */
		if (strlen(Data) == 0 || streq(Data, "^"^"") == 1) {
			new sPasswd[MAX_NAME_LENGTH];
			getstrvar( "sv_password", sPasswd, MAX_NAME_LENGTH );
			snprintf(Text, MAX_TEXT_LENGTH, "The password is: %s.", sPasswd);
			selfmessage(Text);
			return PLUGIN_HANDLED;
		}
	}
	if (streq(Data,"^"^"")) {
		snprintf(Text, MAX_TEXT_LENGTH, "ADMIN Command: %s has removed the server's password.", User);
	} else {
		snprintf(Text, MAX_TEXT_LENGTH, "ADMIN Command: %s has set the server's password.", User);
	}
	say(Text);
	log_command(User,Command,Data);
	snprintf(Msg, MAX_DATA_LENGTH, "sv_password %s", Data);
	exec(Msg);
	return PLUGIN_HANDLED;
}

/* admin_pause
	 admin_unpause */
public admin_pause(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	if (streq(Command, "admin_unpause")==1) {
		execute_command(User,Command,"pausable","0");
	} else {
		execute_command(User,Command,"pausable","1");
	}
	return PLUGIN_HANDLED;
}

/* admin_rcon <cmd> */
public admin_rcon(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	if (check_auth(ACCESS_RCON)==0) {
		selfmessage("Laf. Silly bear.");
		return PLUGIN_HANDLED;
	}
	if (strmatch(Data, "rcon_password", strlen("rcon_password"))==1) {
		reject_message();
		return PLUGIN_HANDLED;
	}
	execute_command(User,Command,"",Data);
	return PLUGIN_HANDLED;
}

/* admin_reload */
public admin_reload(HLCommand,HLData,HLUserName,UserIndex) {
	reload();
	return PLUGIN_HANDLED;
}

/* admin_servercfg <config file> */
public admin_servercfg(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"servercfgfile");
	return PLUGIN_HANDLED;
}

/* admin_teamplay <teamplay> */
public admin_teamplay(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"mp_teamplay");
	return PLUGIN_HANDLED;
}

/* admin_timeleft */
public admin_timeleft(HLCommand,HLData,HLUserName,UserIndex) {
	timeleft();
	return PLUGIN_HANDLED;
}

/* admin_timelimit <timelimit> */
public admin_timelimit(HLCommand,HLData,HLUserName,UserIndex) {
	execute_cmd(HLCommand,HLData,HLUserName,"mp_timelimit");
	return PLUGIN_HANDLED;
}


/* admin_unban <WONID or IP> */
public admin_unban(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	unban(Data);
	log_command(User,Command,Data);
	log_to_file(UserIndex,Command,Data,"addons/adminmod/config/log_banned.txt");
	return PLUGIN_HANDLED;
}

/* admin_userlist [<name>] */
public admin_userlist(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	userlist(Data);
	return PLUGIN_HANDLED;
}