/*
 * ===========================================================================
 *
 * $Id: plugin_menu_mapvote.sma,v 1.0 2005/10/10 19:41:07 sdal Exp $
 *
 *
 * Copyright (c) 1999-2003 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ===========================================================================
 */
#include <plugin>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072

#define ACCESS_HLDSLD_VOTE 1
#define ACCESS_CONTROL_VOTE 2

new AM_VERSION_STRING[] = "2.50.60_rc1";

/************************************************************/
/* EDIT THE MAP NOMINATION TIME, IF YOU WANT AND RECOMPILE	*/
/************************************************************/
/*Nomination settings*/
new g_setnominatetime 		= 90;
new g_setnominatewarntime 	= 30;
new g_setvotetime 			= 30;
/************************************************************/

/*Vote*/
new g_NominatedMaps[9][MAX_NAME_LENGTH];
new g_suggestions;
new g_votestart;
new g_nominatetime;
new g_vote_canceled;

/*Menu*/
#define ITEMS_PER_PAGE 8
new g_UserVoteMenu[MAX_PLAYERS];
new g_UserSelect[MAX_PLAYERS];

/*Map-Settings*/
new g_CurrentMap[MAX_NAME_LENGTH];
new g_NextMap[MAX_NAME_LENGTH];
new g_maxextend;
new g_curextend;

/*Time-Settings*/
new g_timelimit;	//minutes
new g_origtimelimit;//seconds
new g_newtimelimit;//seconds

public plugin_init() {
	plugin_registerinfo("AdminMod Map-Nomination-Vote Plugin","Vote for maps in menu-style which were nominated by players before",AM_VERSION_STRING);
	plugin_registercmd("admin_cancelvote","stop_vote",ACCESS_VOTE_MAP,"admin_cancelvote: Stops map nomination and vote.");
	plugin_registercmd("admin_denymap","denymap",ACCESS_CONTROL_VOTE,"admin_denymap <map>: Removes nomination for this map.");
	plugin_registercmd("admin_startvote","start_nominate",ACCESS_VOTE_MAP,"admin_startvote: Starts map nomination and vote.");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say <map>: Places a nomination for the map.");
	plugin_registerhelp("say",ACCESS_ALL,"say showmaps: Opens vote menu after map nomination to make/change your vote");
	plugin_registerhelp("say",ACCESS_CONTROL_VOTE,"say cancelvote: Cancels the current nomination/vote.");
	plugin_registerhelp("say",ACCESS_CONTROL_VOTE,"say denymap <map>: Removes nomination for this map.");
	plugin_registerhelp("say",ACCESS_HLDSLD_VOTE,"say mapvote: Starts map nomination and menu vote.");
	plugin_registerhelp("say",ACCESS_HLDSLD_VOTE,"say rockthevote: Starts map nomination and menu vote.");
	
	//menu settings
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("close_menu","SetMenuData",ACCESS_ALL);
	
	/*Map-Settings*/
	currentmap(g_CurrentMap,MAX_NAME_LENGTH);
	nextmap(g_NextMap,MAX_NAME_LENGTH);
	g_maxextend=getvar("admin_vote_maxextend");
	g_origtimelimit=getvar("mp_timelimit");
	g_newtimelimit=g_origtimelimit;
	g_timelimit=getvar("mp_timelimit")*60;
	new iWait=g_timelimit - g_setnominatetime - g_setvotetime;
		
	if(getvar("admin_vote_autostart") != 0) {
		/* Call for a vote (nomination + vote time) seconds before map ends */
		new Text[MAX_TEXT_LENGTH];
		snprintf(Text,MAX_TEXT_LENGTH,"Map Nomination starts in %i seconds",iWait);
		plugin_message(Text);
		set_timer("StartMapVote",iWait, 0);
	}
	return PLUGIN_CONTINUE;
}

////////////////////
// ADMIN COMMANDS //
////////////////////
public stop_vote(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	cancel_vote(User,0);
	return PLUGIN_HANDLED;
}

cancel_vote(User[],ID){
	g_vote_canceled=1;
	if(!ID){
		selfmessage("[MAP-NOMINATION] Map nomination and vote cancelled!");
	}else{
		messageex(User,"[MAP-NOMINATION] Map nomination and vote cancelled!",print_chat);
	}
}

public start_nominate(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	start_nomination(User,0);
	return PLUGIN_HANDLED;
}

start_nomination(User[],ID){
	new Text[MAX_TEXT_LENGTH];
	if(!g_nominatetime && !g_votestart){
		g_nominatetime=g_setnominatetime;
		g_vote_canceled=0;
		set_timer("nominate_warning",15,0);
		snprintf(Text,MAX_TEXT_LENGTH,"MAP NOMINATION HAS BEGUN!^nPlease make your map nominations in chat!^n(i.e. ^"de_dust^" or ^"extend^")");
		centersay(Text,12,255,255,255);
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Please make your map nominations in chat (i.e. ^"de_dust^" or ^"extend^"). You have %i seconds left!",g_nominatetime);
		say(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Sorry, a map nomination or vote has already started!");
		if(!ID){
			selfmessage(Text);
		}else{
			messageex(User,Text,print_chat);
		}
	}	
}

public denymap(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	denymap_nominate(Data,User,0);
	return PLUGIN_HANDLED;
}

denymap_nominate(MapName[],User[],ID){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new found;
	new x;
	if(g_nominatetime>0){
		for(i=0;i<=g_suggestions;i++){
			if(strcmp(MapName,g_NominatedMaps[i])==0){
				strinit(g_NominatedMaps[i]);
				found=1;
				break;
			}
		}
		if(!found){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Sorry, no nomination for map '%s' found",MapName);
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Nomination for %s has been removed!",MapName);
			new Maps[9][MAX_NAME_LENGTH];
			for(i=0;i<=g_suggestions;i++){
				if(strlen(g_NominatedMaps[i])!=0){
					strcpy(Maps[x],g_NominatedMaps[i],MAX_NAME_LENGTH);
					x++;
				}
			}
			x--;
			for(i=0;i<=x;i++){
				strcpy(g_NominatedMaps[i],Maps[i],MAX_NAME_LENGTH);
			}
			g_suggestions=x;
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Sorry, a map nomination has not started yet or vote has already begun!");
	}
	if(!ID){
		selfmessage(Text);
	}else{
		messageex(User,Text,print_chat);
	}
}
//
//NOMINATION OF MAPS
//
public StartMapVote(Timer,Repeat,HLName,HLParam) {
	start_nomination("",0);
}
public nominate_warning(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	if(!g_vote_canceled){
		g_nominatetime-=g_setnominatewarntime;
		if(g_nominatetime>0){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Please make your map nominations in chat (i.e. ^"de_dust^" or ^"extend^"). You have %i seconds left!",g_nominatetime);
			say(Text);
			set_timer("nominate_warning",g_setnominatewarntime,0);
		}else{
			if(g_suggestions>0){
				g_votestart=1;
				show_vote("all",0);
				set_timer("vote_calculate",g_setvotetime,0);
				snprintf(Text,MAX_TEXT_LENGTH,"MAP VOTE HAS BEGUN^nPlease make your vote for nominated maps!");
				centersay(Text,12,255,255,255);	
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Please make your vote! You have %i seconds left!",g_setvotetime);
				say(Text);
				say("[MAP-VOTE] You can change your vote with chat message ^"showmaps^"!");
			}else{
				g_votestart=0;
				snprintf(Text,MAX_TEXT_LENGTH,"MAP NOMINATION FAILED!^nNo map nominations are made in chat!");
				centersay(Text,12,255,255,255);
				say("[MAP-NOMINATION]: Sorry. No map nominations available!");
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Next map will be %s",g_NextMap);
				say(Text);
				reset_nominations();
			}
		}
	}else{
		say("[MAP-NOMINATION] Vote cancelled!");
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] Next map will be %s",g_NextMap);
		say(Text);
		reset_nominations();
	}
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new i;
		
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	
	strstripquotes(Data);
	
	if(strncmp(Data,"denymap",7)==0){
		if(access(ACCESS_CONTROL_VOTE)){
			strsubst(Data,"denymap ","",MAX_DATA_LENGTH);
			denymap_nominate(Data,UserName,1);
			return PLUGIN_HANDLED;
		}
	}else if(streq(Data,"cancelvote")==1){
		if(access(ACCESS_CONTROL_VOTE)){
			cancel_vote(UserName,1);
			return PLUGIN_HANDLED;
		}
	}else if(streq(Data,"rockthevote")==1 || streq(Data,"mapvote")==1) {
		if(access(ACCESS_HLDSLD_VOTE)){
			start_nomination(UserName,1);
			return PLUGIN_HANDLED;
		}
	}
	
	if(strcmp(Data,"showmaps")==0){
		if(g_votestart){
			show_votechange(UserName,UserIndex);
		}else{
			messageex(UserName,"[MAP-VOTE] Sorry, no vote started!",print_chat);
			return PLUGIN_HANDLED;
		}
	}
	if(!g_votestart && g_nominatetime>0){
		if(strcmp(Data,"extend")==0){

			strcpy(Data,g_CurrentMap,MAX_NAME_LENGTH);
		}
		if(valid_map(Data)){
			strcpy(Map,Data,MAX_NAME_LENGTH);
			if(g_suggestions<8){
				/*Next Map in mapcycle not needed to nominate*/
				if(strcasecmp(g_NextMap,Map)==0){
					snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] %s is the next map after mapcycle and does not need to be nominated!",g_NextMap);
					say(Text);
					return PLUGIN_HANDLED;
				}
				/*Check, if map already nominated*/
				for(i=0;i<=g_suggestions;i++){
					if(strcasecmp(Map,g_NominatedMaps[i])==0){
						messageex(UserName,"[MAP-NOMINATION] Sorry, this map is already nominated! Maybe chose another one",print_chat);
						return PLUGIN_HANDLED;
					}
				}
				/*Check, if extend is allowed*/
				if(strcasecmp(Map,g_CurrentMap)==0){
					if(g_curextend<=g_maxextend){
						strcpy(g_NominatedMaps[g_suggestions],Map,MAX_NAME_LENGTH);
						g_suggestions++;
						snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] %s nominated extend for this map!",UserName);
						say(Text);
						return PLUGIN_HANDLED;
					}else{
						messageex(UserName,"[MAP-NOMINATION] Sorry, map can't be extended anymore!",print_chat);
						return PLUGIN_HANDLED;
					}	
				}else{
					strcpy(g_NominatedMaps[g_suggestions],Map,MAX_NAME_LENGTH);
					g_suggestions++;
					snprintf(Text,MAX_TEXT_LENGTH,"[MAP-NOMINATION] %s has nominated %s!",UserName,Map);
					say(Text);
					return PLUGIN_HANDLED;
				}
			}else{
				messageex(UserName,"[MAP-NOMINATION] Sorry, maximum of 8 map nominations reached!",print_chat);
				return PLUGIN_HANDLED;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

//
// VOTE MENU AFTER NOMINATION
//

show_vote(User[],UserIndex) {
	new VoteDisplay[512];
	new UserName[MAX_NAME_LENGTH];
	new MapName[MAX_NAME_LENGTH];
	new i;
	new x;
	new key=1;
	new keys;
	new maxplayers=maxplayercount();
	
	snprintf(VoteDisplay,512,"[MAP-VOTE]:^n^n0. nextmap: %s",g_NextMap);
	keys+=512;
	for(i=0;i<=g_suggestions;i++){
		if(strlen(g_NominatedMaps[i])!=0){
			x++;
			if(x>ITEMS_PER_PAGE){
				break;
			}
			if(strcasecmp(g_CurrentMap,g_NominatedMaps[i])==0){
				strcpy(MapName,"EXTEND",MAX_NAME_LENGTH);
			}else{
				strcpy(MapName,g_NominatedMaps[i],MAX_NAME_LENGTH);
			}
			snprintf(VoteDisplay,512,"%s^n%i. %s",VoteDisplay,x,MapName);
			keys |= key;
		}
		key <<= 1;
	}
	
	if(UserIndex!=0){
		g_UserVoteMenu[UserIndex]=1;
		open_menu(UserIndex);
		menu(User,VoteDisplay,keys);
	}else{
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,UserName,MAX_NAME_LENGTH)){
				g_UserVoteMenu[i]=1;
				open_menu(UserIndex);
				menu(UserName,VoteDisplay,keys);
			}
		}
	}
	messageex(User,"[MAP-VOTE] You can change your vote with chat message ^"showmaps^"!",print_chat);
}

show_votechange(User[],UserIndex) {
	new Text[512];
	new UserVote[MAX_NAME_LENGTH];
	if(g_UserSelect[UserIndex]==0){
		snprintf(UserVote,MAX_NAME_LENGTH,"no map");
	}else if(g_UserSelect[UserIndex]==10){
		snprintf(UserVote,MAX_NAME_LENGTH,"nextmap: %s",g_NextMap);
	}else{
		snprintf(UserVote,MAX_NAME_LENGTH,"%s",g_NominatedMaps[g_UserSelect[UserIndex]-1]);
	}
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE]^n^nYou have voted for %s^n^nWill you:^n1. Change your vote^n0. No. It is ok.",UserVote);
	g_UserVoteMenu[UserIndex]=2;
	open_menu(UserIndex);
	menu(User,Text,513);
}
	
public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iSelect;
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_UserVoteMenu[UserIndex]!=0){
		iSelect=strtonum(Data);
		if(g_UserVoteMenu[UserIndex]==1){
			if (iSelect==10){
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] %s has voted for next map %s!",User,g_NextMap);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] %s has voted for %s!",User,g_NominatedMaps[iSelect-1]);			
			}
			g_UserSelect[UserIndex]=iSelect;
			say(Text);
			return PLUGIN_HANDLED;
		}else if(g_UserVoteMenu[UserIndex]==2){
			if(iSelect==1){
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] %s will maybe change his vote!",User);
				say(Text);
				show_vote(User,UserIndex);
				return PLUGIN_HANDLED;
			}
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new iUserIndex;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	iUserIndex=strtonum(Data);
	
	if(g_UserVoteMenu[iUserIndex]!=0){
		reset_array(iUserIndex);
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	g_UserVoteMenu[UserIndex]=0;
	reset_menu(UserIndex);
}


//
// CALCULATION VOTE
//
public vote_calculate(Timer,Repeat,HLName,HLParam) {
	calculate();
}

calculate(){
	new Text[MAX_TEXT_LENGTH];
	snprintf(Text,MAX_TEXT_LENGTH,"MAP VOTE HAS FINISHED!");
	centersay(Text,12,255,255,255);	
	if(!g_vote_canceled){
		new UserName[MAX_NAME_LENGTH];
		new MapVotes[10];
		new maxplayers=maxplayercount();
		new i;
		new winmap;
		new winvotes;
		new votes;
		new votecount;
		/*Calculating votes*/
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,UserName,MAX_NAME_LENGTH)){
				if(g_UserSelect[i]!=0){
					MapVotes[g_UserSelect[i]-1]+=1;
					votecount++;
				}
			}
		}
		/*Find maxvotes and winning map*/
		for(i=0;i<=g_suggestions;i++){
			votes=max(MapVotes[i],winvotes);
			if(votes>winvotes){
				winvotes=MapVotes[i];
				winmap=i;
			}
		}
		
		if(winvotes!=0 && MapVotes[9]<winvotes){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] ^"%s^" has won with %i of %i votes!",g_NominatedMaps[winmap],winvotes,votecount);
			say(Text);
			if(strcmp(g_NominatedMaps[winmap],g_CurrentMap)==0){
				g_curextend++;
				g_newtimelimit+=g_origtimelimit;
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] ^"%s^" will be extended for %i minutes!",g_NominatedMaps[winmap],g_origtimelimit);
				say(Text);
				snprintf(Text,MAX_TEXT_LENGTH, "mp_timelimit %i", g_newtimelimit);
			  	exec(Text);
			  	if(getvar("admin_vote_autostart") != 0) {
					/* Call for a vote (nomination + vote time) seconds before map ends */
					set_timer("StartMapVote", g_timelimit - g_setnominatetime - g_setvotetime, 1); 
				}
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Map change to ^"%s^"!",g_NominatedMaps[winmap]);
				say(Text);
				changelevel(g_NominatedMaps[winmap],3);
			}
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] The majority will continue playing maps after mapcycle.");
			say(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Next map will be %s",g_NextMap);
			say(Text);
		}
	}else{
		say("[MAP-NOMINATE]: Vote was cancelled!");
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Next map will be %s",g_NextMap);
		say(Text);
	}
	reset_nominations();
}


reset_nominations(){
	new i;
	new maxplayers=maxplayercount();
	for(i=0;i<=g_suggestions;i++){
		strinit(g_NominatedMaps[i]);
	}
	for(i=1;i<=maxplayers;i++){
		g_UserVoteMenu[i]=0;
		g_UserSelect[i]=0;
	}
	g_suggestions=0;
	g_nominatetime=0;
	g_vote_canceled=0;
	g_votestart=0;
}
