/*
 * ===========================================================================
 *
 * $Id: plugin_sound.sma,v 1.5 2005/10/08 19:41:07 sdal Exp $
 *
 *
 * Copyright (c) 1999-2003 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ===========================================================================
 */

#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "2.50.60.rc1";

#define ACCESS_SPEAK 64

new g_User[MAX_PLAYERS];

new g_ConnectMsg1[MAX_TEXT_LENGTH]="Customsounds and messages are\nDEACTIVATED for you!\nSay ^".play^" to activate them!";
new g_ConnectMsg0[MAX_TEXT_LENGTH]="Customsounds and messages are\nACTIVATED for you!\nSay ^".stop^" to deactivate them!";

public plugin_init() {
	plugin_registerinfo("AdminMod Sound Plugin","All commands to play sounds at client",AM_VERSION_STRING);
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say '.stop' or '.stopsound': disables all custom sounds for you");
	plugin_registerhelp("say",ACCESS_ALL,"say '.play' or '.playsound': enables all custom sounds for you");
	plugin_registercmd("specmode","specmode",ACCESS_ALL);
	plugin_registercmd("admin_speak","admin_speak",ACCESS_SPEAK,"admin_speak <target> <msg>: Speaks words or plays sound to target.");
	plugin_registercmd("admin_speakall","admin_speakall",ACCESS_SPEAK,"admin_speakall <msg>: Speaks words or plays sound to everyone.");
	plugin_registercmd("admin_speakteam","admin_speakteam",ACCESS_SPEAK,"admin_speakteam <teamnumber> <msg>: Speaks words or plays sound to everyone on team.");

	return PLUGIN_CONTINUE;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Msg [MAX_TEXT_LENGTH];
	new i;
	new found;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	strstripquotes(Data);
	
	if(strcasecmp(Data, ".stopsound") ==0 || strcasecmp(Data, ".stop") ==0){
		snprintf(Msg,MAX_TEXT_LENGTH,"You won`t hear the custom sounds any longer. Use '.playsound' or '.play' if you want to enable them.");
		i=0;
		found=1;
        }else if(strcasecmp(Data, ".playsound") ==0 || strcasecmp(Data, ".play") ==0){
		snprintf(Msg,MAX_TEXT_LENGTH,"You have enabled custom sounds. Use '.stopsound' or '.stop' if you want to turn them off.");
		i=1;
		found=1;
		return PLUGIN_HANDLED;
	}
	
	if(found){
		messageex(User,Msg,print_chat);
		sound_set_key(User,i);		
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public specmode(HLCommand,HLData,HLUserName,UserIndex) {
	new strName[MAX_NAME_LENGTH];
	convert_string(HLUserName, strName, MAX_NAME_LENGTH);
	if(g_User[UserIndex]==0){
		g_User[UserIndex]=1;
		set_timer("show_welcome",30,0,strName);
	}
}

public show_welcome(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new UserIndex;
	get_userindex(User,UserIndex);
	convert_string(HLParam,User,MAX_NAME_LENGTH);
	if(sound_get_key(User)){
		snprintf(Text,MAX_TEXT_LENGTH,"Hi %s!^n^n%s",User,g_ConnectMsg1);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Hi %s!^n^n%s",User,g_ConnectMsg0);
	}
	messageex(User,Text,print_tty);
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public admin_speak(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new Speak[MAX_DATA_LENGTH];
	new Cmd[MAX_DATA_LENGTH];
	
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);

	strbreak(Data, Target, Cmd, MAX_DATA_LENGTH);
	if (Cmd[0] == NULL_CHAR) {
		selfmessage( "Unparsable format: no command found.");
		return PLUGIN_HANDLED;
	}

	if(check_user(Target)==0) {
		selfmessage( "Unrecognized player: ");
		selfmessage( Target);
		return PLUGIN_HANDLED;
	}
	strsubst(Cmd," ( ","(",MAX_DATA_LENGTH);
	strsubst(Cmd," )",")",MAX_DATA_LENGTH);
	snprintf(Speak, MAX_DATA_LENGTH, "^"%s^"", Cmd); 
	
	if(sound_get_key(Target)){
		speakto(Target,Speak);
	}
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}

public admin_speakall(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Speak[MAX_DATA_LENGTH];
	
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);

	strsubst(Data," ( ","(",MAX_DATA_LENGTH);
	strsubst(Data," )",")",MAX_DATA_LENGTH);
	snprintf(Speak, MAX_DATA_LENGTH, "^"%s^"", Data); 
	sound_to_all(Speak);
	log_command(User,Command,Data);
	return PLUGIN_HANDLED; 
}

public admin_speakteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Cmd[MAX_DATA_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new ExecTeam = 0;
	new strTeam[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Speak[MAX_DATA_LENGTH];
		
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);

	strbreak(Data, strTeam, Cmd, MAX_DATA_LENGTH);
	
	if (strlen(Cmd) == 0) {
		selfmessage( "Unparsable format: no command found.");
		return PLUGIN_HANDLED;
	}
	ExecTeam = strtonum(strTeam);
	snprintf(Speak, MAX_DATA_LENGTH, "^"%s^"", Cmd);
	if(ExecTeam > 0) {
		sound_to_all(Speak,ExecTeam);
	} else {
		selfmessage("The team to exec must be a number.");
	}
	log_command(User,Command,Data);
	return PLUGIN_HANDLED;
}
