/*
 * ===========================================================================
 *
 * $Id: plugin_vote.sma,v 1.0 2005/06/11 19:41:07 sdal Exp $
 *
 *
 * Copyright (c) 1999-2003 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * ===========================================================================
 */

#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "2.50.60.rc1";

#define MAX_MAPS 30
#define ITEMS_PER_PAGE 7
#define NEXT	8
#define BACK	9
#define CANCEL	10

new g_File[MAX_TEXT_LENGTH]="addons/adminmod/config/map_vote.ini";
new g_Maps[MAX_MAPS][MAX_TEXT_LENGTH];
new g_loaded;

new g_UserMenu[MAX_PLAYERS];
new g_UserSelect[MAX_PLAYERS];

new g_MapsSelect[MAX_MAPS];
new g_UserMapSelect[MAX_PLAYERS]={-1,-1,...};

new g_timerindex;
new g_extend;
new g_maxextend;
new g_CurrentMap[MAX_NAME_LENGTH];
new g_NextMap[MAX_NAME_LENGTH];
new g_votetime;
new g_AbortVote;
new g_VoteInProgress;

public plugin_init() {
	plugin_registerinfo("AdminMod Vote Plugin","All vote commands.",AM_VERSION_STRING);
	plugin_registercmd("admin_vote_cancel","admin_abort_vote",ACCESS_ABORT_VOTE,"admin_vote_cancel: Aborts a vote in progress.");
	plugin_registercmd("admin_vote_kick","admin_vote_kick",ACCESS_VOTE_KICK,"admin_vote_kick <target>: Starts a vote to kick target.");
	plugin_registercmd("admin_vote_map","admin_vote_map",ACCESS_VOTE_MAP,"admin_vote_map <map>: Starts a vote to change the map.");
	plugin_registercmd("admin_vsay","admin_vsay",ACCESS_SAY,"admin_vsay <question>: Presents question as a vote.");
	
	new MenuEnabled[MAX_TEXT_LENGTH];
	getstrvar("amv_enable_beta",MenuEnabled,MAX_TEXT_LENGTH);
	if(getvar("file_access_read") && strstrx(MenuEnabled,"menu1")!=-1){
		plugin_registercmd("admin_vote_maps","am_vote_maps",ACCESS_VOTE_MAP, "admin_vote_maps <[votetime]>: displays mapvote to all players on server. Optional: overrides standard votetime");
		plugin_registercmd("admin_vote_time","am_vote_time",ACCESS_VOTE_MAP, "admin_vote_time <votetime>: sets votetime");
		plugin_registercmd("admin_vote_read","am_vote_read",ACCESS_CONFIG, "admin_vote_read <file>: reads a new mapvote file");
		
		plugin_registercmd("say_team","HandleSay",ACCESS_ALL,"say votemaps: opens votemenu");
		plugin_registercmd("say","HandleSay",ACCESS_ALL,"say votemaps: opens votemenu");
		//plugin_registercmd("admin_vote_debug","am_vote_debug",ACCESS_CONFIG);

		//check for selection
		plugin_registercmd("menuselect","menuselect",ACCESS_ALL);

		//cancel vote_menu (executed by menu plugin)
		plugin_registercmd("close_menu","clear_menu",ACCESS_ALL);
		
		//destroy HL-Console Command votemaps
		plugin_registercmd("votemaps","votemaps",ACCESS_ALL);

		if(!get_vaultnumdata("menu_vote_time",g_votetime)){
			set_vaultnumdata("menu_vote_time",30);
			g_votetime=30;
		}

		currentmap(g_CurrentMap,MAX_NAME_LENGTH);
		nextmap(g_NextMap,MAX_NAME_LENGTH);
		g_maxextend=getvar("admin_vote_maxextend");

		read_file(g_File);
	}else{
		log("[ADMIN-VOTE-PLUGIN] file_access_read 1 or amv_enable_beta ^"menu1^" not set in adminmod.cfg! Some functions disabled!");
	}
	
	return PLUGIN_CONTINUE;
}

/* admin_vote_kick <target> */
public admin_vote_kick(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new sAuthID[MAX_AUTHID_LENGTH];

	if (vote_allowed()!=1 || g_VoteInProgress!=0) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}

	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	strstripquotes(Data);
	
	if (check_user(Data) == 1) {
		new real_user[MAX_NAME_LENGTH];
		get_username(Data,real_user,MAX_NAME_LENGTH);
		say_command(User,Command,Data);
		if(check_immunity(real_user)!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't kick %s, you silly bear.", real_user);
			messageex(User, Text, print_chat);
		} else {
			snprintf(Text, MAX_TEXT_LENGTH, "Kick %s?", real_user);
			if(getvar("sv_lan")==1) {
				if (vote(Text,"Yes","No","HandleKickVote",real_user)) {
					g_VoteInProgress = 1;
					g_AbortVote = 0;
				}
			} else {
				get_userAuthID(real_user,sAuthID);
				if (vote(Text,"Yes","No","HandleKickVote",sAuthID)) {
					g_VoteInProgress = 1;
					g_AbortVote = 0;
				}
			}
		}
	} else {
		selfmessage("Unrecognized user name ");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

/* Handle a kick vote's results. */
public HandleKickVote(WinningOption,HLUser,VoteCount,UserCount) {
	new strNumber[MAX_NUMBER_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new VoteUser[MAX_DATA_LENGTH];
	convert_string(HLUser,VoteUser,MAX_DATA_LENGTH);

	g_VoteInProgress = 0;
	if (WinningOption == 1) {
		new Ratio = getvar("kick_ratio");
		if (VoteCount >= Ratio*UserCount/100) {
			if (g_AbortVote) {
				say("Kick vote was aborted by an admin");
			} else {
				set_timer("KickUser",10,1,VoteUser);
			}
		} else {
			numtostr(Ratio*UserCount/100,strNumber);
			snprintf(Text, MAX_TEXT_LENGTH, "Kick vote succeeded, but not enough votes for kick (needed %s)",strNumber);
			say(Text);
		}
	} else {
		say("Kick vote failed.");
	}
}

/* Actually kick the user, unless aborted. */
public KickUser(Timer,Repeat,HLUserName,HLParam) {
	new VoteUser[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLParam,VoteUser,MAX_DATA_LENGTH);
	if (g_AbortVote) {
		say("Kick vote was Aborted by an admin");
	}
	else {
		snprintf(Text, MAX_TEXT_LENGTH, "%s was kicked due to a vote.", VoteUser);
		say(Text);
		message(VoteUser,"You have been kicked due to a vote.");
		kick(VoteUser);
	}
}

/* admin_vote_map <map> */
public admin_vote_map(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];

	if (vote_allowed()!=1 || g_VoteInProgress!=0) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}
	
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	
	if (valid_map(Data) == 1) {
		snprintf(Text, MAX_TEXT_LENGTH, "Change map to %s?", Data);
		log(Text);
		if (vote(Text,"Yes","No","HandleMapVote",Data)) {
			g_VoteInProgress = 1;
			g_AbortVote=0;
		}

	} else {
		snprintf(Text, MAX_TEXT_LENGTH, "You cannot vote for map %s on this server",Data);
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}

/* Handle a map vote's results. */
public HandleMapVote(WinningOption,HLMap,VoteCount,UserCount) {
	new strNumber[MAX_NUMBER_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new VoteMap[MAX_DATA_LENGTH];
	convert_string(HLMap,VoteMap,MAX_DATA_LENGTH);
	g_VoteInProgress = 0;

	if (WinningOption == 1) {
		new Ratio = getvar("map_ratio");
		if (VoteCount >= Ratio*UserCount/100) {
			if (g_AbortVote) {
				say("Map vote was aborted by an admin");
			} else {
				set_timer("VoteChangeMap",10,1,VoteMap);
			}
		} else {
			numtostr(Ratio*UserCount/100,strNumber);
			snprintf(Text, MAX_TEXT_LENGTH, "Map vote succeeded, but not enough votes for change (needed %s)", strNumber);
			say(Text);
		}
	} else {
		say("Map vote failed.");
	}
}

/* Actually kick the user, unless aborted. */
public VoteChangeMap(Timer,Repeat,HLUserName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new VoteMap[MAX_DATA_LENGTH];
	convert_string(HLParam,VoteMap,MAX_DATA_LENGTH);
	if (g_AbortVote) {
		say("Map vote aborted by an admin");
	}
	else {
		snprintf(Text, MAX_TEXT_LENGTH, "Changing map to %s due to vote.", VoteMap);
		say(Text);
		changelevel(VoteMap, 4);
	}
}

/* admin_vsay <question> */
public admin_vsay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	strstripquotes(Data);
	if (vote_allowed()!=1 || g_VoteInProgress!=0) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}
	g_VoteInProgress=1;
	g_AbortVote=0;
	log_command(User,Command,Data);
	vote(Data,"Yes","No","HandleVsay", Data);
	return PLUGIN_HANDLED;
}

public HandleVsay(WinningOption,HLData,VoteCount,UserCount) {
	if (g_AbortVote) {
		new Data[MAX_DATA_LENGTH];
		new Text[MAX_TEXT_LENGTH];
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		snprintf(Text, MAX_TEXT_LENGTH, "^"%s^": Option #%i won with %i / %i votes.", Data, WinningOption, VoteCount, UserCount);
		say(Text);
	}else{
		say("Vote aborted by an admin");
	}
	g_VoteInProgress=0;
}

/* Allows a vote to be Aborted */
public admin_abort_vote(HLCommand,HLData,HLUserName,UserIndex) {
	if (g_VoteInProgress) {
		g_VoteInProgress=0;
		g_AbortVote=1;
		kill_timer(g_timerindex);
		g_timerindex=0;
		selfmessage("The vote in progress will be aborted.");
	}
	else {
		selfmessage("There are no votes in progress that can be aborted.");
	}
	return PLUGIN_HANDLED;
}

//
//MAP VOTE with menu
//
read_file(FileName[]){
	new Text[MAX_TEXT_LENGTH];
	new iFileSize;
	new i;
	
	for(i=0;i<=MAX_PLAYERS;i++){
		reset_array(i);
		g_UserMapSelect[i]=-1;
	}
	
	for(i=0;i<=g_loaded;i++){
		strinit(g_Maps[i]);
	}	
	
	if(fileexists(FileName)){
		iFileSize=filesize(FileName);
		if(iFileSize>=MAX_MAPS){
			iFileSize=MAX_MAPS-1;
		}
		for(i=1;i<=iFileSize;i++){
			readfile(FileName,g_Maps[g_loaded],i,MAX_TEXT_LENGTH);
			g_loaded++;
		}
		g_loaded--;
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Can't find ^"%s^"",FileName);
		selfmessage(Text);
	}
}

public clear_menu(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new iUserIndex;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iUserIndex=strtonum(Data);
	
	if(g_UserMenu[iUserIndex]!=0){
		reset_array(iUserIndex);
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	g_UserSelect[UserIndex]=0;
	g_UserMenu[UserIndex]=0;
	reset_menu(UserIndex);
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(g_VoteInProgress){
		if(strcmp(Data,"votemaps")==0){
			execclient(UserName,"menuselect 10");
			execclient(UserName,"votemaps");
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public am_vote_maps(HLCommand,HLData,HLUserName,UserIndex){
	if(vote_allowed() && g_VoteInProgress==0){
		new Text[MAX_TEXT_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new Player[MAX_NAME_LENGTH];
		new i;
		new ivotetime;
		new maxplayers=maxplayercount();

		convert_string(HLData,Data,MAX_DATA_LENGTH);

		if(strlen(Data)!=0){
			ivotetime=strtonum(Data);
			if(ivotetime<=0){
				ivotetime=g_votetime;
			}
		}else{
			ivotetime=g_votetime;
		}

		g_timerindex=set_timer("calc_vote",ivotetime,0);
		g_VoteInProgress=1;
		g_AbortVote=0;

		snprintf(Text,MAX_TEXT_LENGTH,"Please make your map decision!^nUse ^"votemaps^" in chat!^nYou have %i seconds for vote!!",ivotetime);
		centersay(Text,12,255,255,255);
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Please make your map decision! Use ^"votemaps^" in chat! You have %i seconds for vote!!",ivotetime);
		say(Text);

		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Player,MAX_NAME_LENGTH)){
				execclient(Player,"menuselect 10");
				if(sound_get_key(Player)){
					speakto(Player,"gman/gman_choose2");
				}
				execclient(Player,"votemaps");
			}
		}
	}else{
		selfmessage("[MAP-VOTE] A map vote is not allowed at the moment!");
	}
	return PLUGIN_HANDLED;
}

public votemaps(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	vote_menu(UserName,UserIndex);
	return PLUGIN_HANDLED;
}

vote_menu(UserName[],UserIndex){
	new Text[512];
	new i;
	new x;
	new keys;
	new key=1;
	
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE]^n");
	for(i=g_UserSelect[UserIndex];i<=g_loaded;i++){
		x++;
		if(x>ITEMS_PER_PAGE){
			break;
		}else{
			if(strcmp(g_Maps[i],g_CurrentMap)==0 && g_extend<g_maxextend){
				snprintf(Text,512,"%s^n%i. Extend (%i)",Text,x,g_MapsSelect[i]);
				keys |= key;
			}else if(strcmp(g_Maps[i],g_CurrentMap)==0 && g_extend>=g_maxextend){
				snprintf(Text,512,"%s^n%i. Extend",Text,x);
			}else{
				snprintf(Text,512,"%s^n%i. %s (%i)",Text,x,g_Maps[i],g_MapsSelect[i]);
				keys |= key;
			}
		}
		key <<= 1;
	}
	snprintf(Text,MAX_TEXT_LENGTH,"%s^n",Text);
	if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE < g_loaded){
		if(g_UserSelect[UserIndex]==0){
			strcat(Text,"^n8. Next",512);
			keys+=128;
		}else{
			strcat(Text,"^n8. Next - 9. Back",512);
			keys+=384;
		}
	}else if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE >= g_loaded && g_UserSelect[UserIndex]!=0){
		strcat(Text,"^n9. Back",512);
		keys+=256;
	}
	strcat(Text,"^n0. Cancel",512);
	keys+=512;
	g_UserMenu[UserIndex]=1;
	open_menu(UserIndex);
	menu(UserName,Text,keys);
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new iSelect;
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		iSelect=strtonum(Data);
		if(iSelect==NEXT){ 	
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]+ITEMS_PER_PAGE;
			vote_menu(UserName,UserIndex);
		}else if(iSelect==BACK){
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]-ITEMS_PER_PAGE;
			vote_menu(UserName,UserIndex);
		}else if(iSelect==CANCEL){
			reset_array(UserIndex);
		}else{
			g_UserSelect[UserIndex]+=iSelect-1;
			if(g_UserMapSelect[UserIndex]!=-1){
				snprintf(Data,MAX_DATA_LENGTH,"[MAP-VOTE] %s removed his previous vote for %s",UserName,g_Maps[g_UserMapSelect[UserIndex]]);
				say(Data);
				g_MapsSelect[g_UserMapSelect[UserIndex]]-=1;
			}
			snprintf(Data,MAX_DATA_LENGTH,"[MAP-VOTE] %s voted for %s",UserName,g_Maps[g_UserSelect[UserIndex]]);
			say(Data);
			g_MapsSelect[g_UserSelect[UserIndex]]+=1;
			g_UserMapSelect[UserIndex]=g_UserSelect[UserIndex];
			reset_array(UserIndex);
		}
	}
	return PLUGIN_CONTINUE;
}

public calc_vote(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new maxplayers=maxplayercount();
	new iWinning=MAX_MAPS;
	new ifound;
	new i;
	new iTimelimit;
	if(!g_AbortVote){
		g_timerindex=0;
		for(i=0;i<=g_loaded;i++){
			if(g_MapsSelect[i]!=0){
				if(g_MapsSelect[iWinning]<g_MapsSelect[i]){
					iWinning=i;
					ifound=1;
				}else if(g_MapsSelect[iWinning]==g_MapsSelect[i]){
					ifound=0;
				}
			}
		}
		if(ifound){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] %s wins with %i votes.",g_Maps[iWinning],g_MapsSelect[iWinning]);
			say(Text);

			if(strcmp(g_CurrentMap,g_Maps[iWinning])==0){
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Extend %s for 15 minutes.",g_Maps[iWinning]);
				say(Text);
				iTimelimit=getvar("mp_timelimit");
				iTimelimit += 15;
				snprintf(Text,MAX_TEXT_LENGTH,"mp_timelimit %i",iTimelimit);
				exec(Text);
				g_extend++;
			}else{
				if(strcmp(g_NextMap,g_Maps[iWinning])!=0){
					changelevel(g_Maps[iWinning],4);
				}
				snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Changing to %s",g_Maps[iWinning]);
				say(Text);
			}
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] No map gots enough votes! Vote failed!");
			say(Text);
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Map vote aborted by an admin");
		say(Text);
	}
	g_VoteInProgress=0;
	for(i=1;i<=maxplayers;i++){
		g_UserMapSelect[i]=-1;
	}
	for(i=0;i<=g_loaded;i++){
		g_MapsSelect[i]=0;
	}
}

//
// ADMIN FUNCTIONS
//

public am_vote_time(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		iData=strtonum(Data);
		if(iData>=0){
			set_vaultnumdata("menu_vote_time",iData);
			g_votetime=iData;
		}
	}
	
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] map vote time is set to %i seconds!",g_votetime);	
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

public am_vote_read(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	read_file(Data);
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] new maps loaded",g_votetime);	
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

/*
public am_vote_debug(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new Player[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	
	snprintf(Text,MAX_TEXT_LENGTH,"******* [MAP-VOTE] *******");
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Settings:");
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Currentmap: %s",g_CurrentMap);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Nextmap: %s",g_NextMap);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* current map extends: %i",g_extend);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* max map extends: %i",g_maxextend);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* vote started (!=0): %i",g_timerindex);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* votetime: %i",g_votetime);
	selfmessage(Text);
	selfmessage("**************************");
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			snprintf(Text,MAX_TEXT_LENGTH,"* Player: %s",Player);
			selfmessage(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"* - in menu: %i",g_UserMenu[i]);
			selfmessage(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"* - his select: %i",g_UserSelect[i]);
			selfmessage(Text);
			if(g_UserMapSelect[UserIndex]!=-1){
				snprintf(Text,MAX_TEXT_LENGTH,"* - his map select: %s",g_Maps[g_UserMapSelect[UserIndex]]);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"* - his map select: no map selected");
			}
			selfmessage(Text);
		}
	}
	selfmessage("**************************");
	snprintf(Text,MAX_TEXT_LENGTH,"* map_vote.ini: %s",g_File);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* loaded maps: %i",g_loaded);
	selfmessage(Text);
	for(i=0;i<=g_loaded;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"* map (x): %s (%i)",g_Maps[i],g_MapsSelect[i]);
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}*/

